import poser, wx, os, os.path, ConfigParser

# Global variables
APPNAME = "Chop it up"
POSER_VERSION = int(float(poser.Version()))
POSER_BUILD = int(poser.AppVersion().rsplit('.',1)[1])
VERSION = '1.2.2'
APPTITLE = '%s v%s' % (APPNAME, VERSION)

UI_WIDTH = 400
UI_HEIGHT = 250

P_UNIT = 0.3

def ShowAlert(message, title=None):
	windowtitle = title or APPTITLE
	msg = wx.MessageDialog(None, message, caption=windowtitle, style=wx.OK)
	msg.ShowModal()
	
class MagicBox ( wx.Frame ):
	
	def __init__( self, parent ):
		wx.Frame.__init__ ( self, parent, id = wx.ID_ANY, title = u"Mystic's Magic Box", pos = wx.DefaultPosition, size = wx.Size( 337,213 ), style = wx.DEFAULT_FRAME_STYLE|wx.TAB_TRAVERSAL )
		
		self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
		
		bSiz_MagicBox = wx.BoxSizer( wx.VERTICAL )
		
		self.wnd_MagicBox = wx.Panel( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer3 = wx.BoxSizer( wx.HORIZONTAL )
		
		bSiz_Main = wx.BoxSizer( wx.VERTICAL )
		
		gSizer1 = wx.GridSizer( 4, 4, 0, 0 )
		
		self.m_staticText1 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"Box", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText1.Wrap( -1 )
		gSizer1.Add( self.m_staticText1, 0, wx.ALL, 5 )
		
		self.m_staticText2 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"Min", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText2.Wrap( -1 )
		gSizer1.Add( self.m_staticText2, 0, wx.ALL, 5 )
		
		self.m_staticText3 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"Max", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText3.Wrap( -1 )
		gSizer1.Add( self.m_staticText3, 0, wx.ALL, 5 )
		
		self.m_staticText4 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"Hide", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText4.Wrap( -1 )
		gSizer1.Add( self.m_staticText4, 0, wx.ALL, 5 )
		
		self.m_staticText5 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"TOP", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText5.Wrap( -1 )
		gSizer1.Add( self.m_staticText5, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_TOPLo = wx.TextCtrl( self.wnd_MagicBox, wx.ID_ANY, u"52", wx.DefaultPosition, wx.Size( 50,-1 ), 0 )
		gSizer1.Add( self.ctl_TOPLo, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_TOPHi = wx.TextCtrl( self.wnd_MagicBox, wx.ID_ANY, u"76", wx.DefaultPosition, wx.Size( 50,-1 ), 0 )
		gSizer1.Add( self.ctl_TOPHi, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_Top = wx.CheckBox( self.wnd_MagicBox, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		gSizer1.Add( self.ctl_Top, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.m_staticText6 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"MIDDLE", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText6.Wrap( -1 )
		gSizer1.Add( self.m_staticText6, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_MIDLo = wx.TextCtrl( self.wnd_MagicBox, wx.ID_ANY, u"28", wx.DefaultPosition, wx.Size( 50,-1 ), 0 )
		gSizer1.Add( self.ctl_MIDLo, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_MIDHi = wx.TextCtrl( self.wnd_MagicBox, wx.ID_ANY, u"52", wx.DefaultPosition, wx.Size( 50,-1 ), 0 )
		gSizer1.Add( self.ctl_MIDHi, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_Middle = wx.CheckBox( self.wnd_MagicBox, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		gSizer1.Add( self.ctl_Middle, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.m_staticText7 = wx.StaticText( self.wnd_MagicBox, wx.ID_ANY, u"BOTTOM", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText7.Wrap( -1 )
		gSizer1.Add( self.m_staticText7, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_BOTLo = wx.TextCtrl( self.wnd_MagicBox, wx.ID_ANY, u"0", wx.DefaultPosition, wx.Size( 50,-1 ), 0 )
		gSizer1.Add( self.ctl_BOTLo, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_BOTHi = wx.TextCtrl( self.wnd_MagicBox, wx.ID_ANY, u"28", wx.DefaultPosition, wx.Size( 50,-1 ), 0 )
		gSizer1.Add( self.ctl_BOTHi, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		self.ctl_Bottom = wx.CheckBox( self.wnd_MagicBox, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		gSizer1.Add( self.ctl_Bottom, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		
		bSiz_Main.Add( gSizer1, 1, wx.EXPAND, 5 )
		
		bSizer5 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_Defaults = wx.Button( self.wnd_MagicBox, wx.ID_ANY, u"Defaults", wx.DefaultPosition, wx.DefaultSize, wx.BU_EXACTFIT )
		bSizer5.Add( self.ctl_Defaults, 0, wx.ALL, 5 )
		
		self.ctl_Save = wx.Button( self.wnd_MagicBox, wx.ID_ANY, u"Save ...", wx.DefaultPosition, wx.DefaultSize, wx.BU_EXACTFIT )
		bSizer5.Add( self.ctl_Save, 0, wx.ALL, 5 )
		
		
		bSiz_Main.Add( bSizer5, 0, wx.EXPAND, 5 )
		
		
		bSizer3.Add( bSiz_Main, 1, wx.EXPAND, 5 )
		
		bSizer4 = wx.BoxSizer( wx.VERTICAL )
		
		self.ctl_Apply = wx.Button( self.wnd_MagicBox, wx.ID_ANY, u"DO IT!!", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer4.Add( self.ctl_Apply, 1, wx.ALL|wx.EXPAND, 5 )
		
		self.ctl_MakeMC6 = wx.CheckBox( self.wnd_MagicBox, wx.ID_ANY, u"Use pose file", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.ctl_MakeMC6.SetValue(True) 
		bSizer4.Add( self.ctl_MakeMC6, 0, wx.ALL, 5 )
		
		self.ctl_Sync = wx.CheckBox( self.wnd_MagicBox, wx.ID_ANY, u"Sync with prop", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer4.Add( self.ctl_Sync, 0, wx.ALL, 5 )
		
		
		bSizer3.Add( bSizer4, 0, wx.EXPAND, 5 )
		
		
		self.wnd_MagicBox.SetSizer( bSizer3 )
		self.wnd_MagicBox.Layout()
		bSizer3.Fit( self.wnd_MagicBox )
		bSiz_MagicBox.Add( self.wnd_MagicBox, 1, wx.EXPAND |wx.ALL, 5 )
		
		
		self.SetSizer( bSiz_MagicBox )
		self.Layout()
		self.ctl_StatusBar = self.CreateStatusBar( 1, wx.ST_SIZEGRIP, wx.ID_ANY )
		self.mnu_MenuBar = wx.MenuBar( 0 )
		self.mnu_Presets = wx.Menu()
		self.itm_Save = wx.MenuItem( self.mnu_Presets, wx.ID_ANY, u"Save preset", wx.EmptyString, wx.ITEM_NORMAL )
		self.mnu_Presets.AppendItem( self.itm_Save )
		
		self.itm_Manage = wx.MenuItem( self.mnu_Presets, wx.ID_ANY, u"Manage presets", wx.EmptyString, wx.ITEM_NORMAL )
		self.mnu_Presets.AppendItem( self.itm_Manage )
		
		self.mnu_Presets.AppendSeparator()
		
		self.mnu_MenuBar.Append( self.mnu_Presets, u"Presets" ) 
		
		self.SetMenuBar( self.mnu_MenuBar )
		
		
		self.Centre( wx.BOTH )
		
		# Connect Events
		self.ctl_Defaults.Bind( wx.EVT_BUTTON, self.SetDefaults )
		self.ctl_Save.Bind( wx.EVT_BUTTON, self.Save )
		self.ctl_Apply.Bind( wx.EVT_BUTTON, self.Apply )
		self.Bind( wx.EVT_MENU, self.Save, id = self.itm_Save.GetId() )
		self.Bind( wx.EVT_MENU, self.Manage, id = self.itm_Manage.GetId() )
	
	def __del__( self ):
		pass
	
	
	# Virtual event handlers, overide them in your derived class
	def SetDefaults( self, event ):
		event.Skip()
	
	def Save( self, event ):
		event.Skip()
	
	def Apply( self, event ):
		event.Skip()
	
	
	def Manage( self, event ):
		event.Skip()

class ListSelector ( wx.Dialog ):
	
	def __init__( self, parent ):
		wx.Dialog.__init__ ( self, parent, id = wx.ID_ANY, title = u"Preset editor", pos = wx.DefaultPosition, size = wx.Size( 257,432 ), style = wx.CAPTION|wx.DEFAULT_DIALOG_STYLE )
		
		self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
		
		box_Configure = wx.BoxSizer( wx.VERTICAL )
		
		ctl_PresetListChoices = []
		self.ctl_PresetList = wx.CheckListBox( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, ctl_PresetListChoices, wx.LB_ALWAYS_SB|wx.LB_MULTIPLE|wx.LB_SORT )
		box_Configure.Add( self.ctl_PresetList, 1, wx.ALL|wx.EXPAND, 5 )
		
		box_Select = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_SelectAll = wx.Button( self, wx.ID_ANY, u"Select All", wx.DefaultPosition, wx.DefaultSize, 0 )
		box_Select.Add( self.ctl_SelectAll, 0, wx.ALL, 5 )
		
		self.ctl_SelectNone = wx.Button( self, wx.ID_ANY, u"Select None", wx.DefaultPosition, wx.DefaultSize, 0 )
		box_Select.Add( self.ctl_SelectNone, 0, wx.ALL, 5 )
		
		
		box_Configure.Add( box_Select, 0, wx.EXPAND, 5 )
		
		box_Buttons = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_SelectPresets = wx.Button( self, wx.ID_OK, u"Select", wx.DefaultPosition, wx.DefaultSize, 0 )
		box_Buttons.Add( self.ctl_SelectPresets, 0, wx.ALL, 5 )
		
		self.ctl_Cancel = wx.Button( self, wx.ID_CANCEL, u"Cancel", wx.DefaultPosition, wx.DefaultSize, 0 )
		box_Buttons.Add( self.ctl_Cancel, 0, wx.ALL, 5 )
		
		
		box_Configure.Add( box_Buttons, 0, wx.EXPAND, 5 )
		
		
		self.SetSizer( box_Configure )
		self.Layout()
		
		self.Centre( wx.BOTH )
		
		# Connect Events
		self.ctl_SelectAll.Bind( wx.EVT_BUTTON, self.SelectAll )
		self.ctl_SelectNone.Bind( wx.EVT_BUTTON, self.SelectNone )
		self.ctl_SelectPresets.Bind( wx.EVT_BUTTON, self.SelectPresets )
		self.ctl_Cancel.Bind( wx.EVT_BUTTON, self.Cancel )
		
class Selector(ListSelector):
	def __init__(self, names, title=None, buttontext=None):
		ListSelector.__init__(self, None)
		
		if title:
			self.SetTitle(title)
			
		if buttontext:
			self.ctl_SelectPresets.SetLabel(buttontext)
		
		for name in names:
			self.ctl_PresetList.Append(name)
			
	def __del__( self ):
		pass

	def SelectAll( self, event ):
		self.ctl_PresetList.SetChecked(range(self.ctl_PresetList.GetCount()))
	
	def SelectNone( self, event ):
		self.ctl_PresetList.SetChecked(())
		
	def SelectPresets( self, event ):
		self.EndModal(1)
	
	def Cancel( self, event ):
		self.EndModal(0)

class poserActor(object):
	def __init__(self, actor):
		self.actor = actor
		
	def IsAFigure(self):
		return isinstance(self, poser.FigureType)
		
	def IsBodyPart(self):
		return self.actor.IsBodyPart()
		
	def IsNotReal(self, AllowBodyParts=False):
		
		# Timesavers
		a = self.actor
		name = a.InternalName()
		
		if self.IsBodyPart() and AllowBodyParts == True: return 0
		if a.IsHairProp(): return False	
		if not a.IsProp(): return True	
		if name.startswith('GoalCenterOfMass') or name.startswith('CenterOfMass') or name.startswith('FocusDistanceControl'): return True	
		if a.IsBase() or a.IsDeformer() or a.IsZone(): return True
		
		return False
		
	def ItsFigure(self):
		return self.actor.ItsFigure()
		
	def Name(self, useFig=False):
		if self.IsBodyPart() and useFig == True:
			return self.ItsFigure().Name()
		else:
			return self.actor.Name()
	
	def PoserActor(self):
		return self.actor
		
	def SelectAllMaterials(self):
		for m in self.actor.Materials():
			m.SetSelected(True)
			
class poserMat(object):
	def __init__(self, material, version, getMaps=True, useExt=False, compatibility=False):
		'''
		material = a reference to a Poser Material object
		getMaps = Identify the principle texture map for each channel
		useExt = Use external names for node inputs instead of internal names
		'''
		
		self.material = material
		self.root = material.ShaderTree().Node(0)
		self.tree = material.ShaderTree()
		
		# Keep a list of nodes holding the principle texture maps in the shader
		self.mapidx = ["color", "alt_color", "specular", "alt_specular", "bump", "displacement", "transparency", "reflection", "specular_color"]
		
		self.mapnodes = []
		if getMaps:
			self.GetMapNodes()
		else:
			self.mapnodes = [None, None, None, None, None, None, None, None, None]
		
		# Maintain a dictionary to cross reference Input external names with their internal names
		self.names = {}
		self.useExt = useExt
		
		# Set up node references
		self.DefineNodeTypes(POSER_VERSION, compatibility=compatibility)
						
	def AddNode(self, type, name=None, loc=None, collapsed=True, **kw):
		
		''' Creates a node '''
		
		# Create the node
		node = self.tree.CreateNode(self.codes[type])
		
		# Configure it
		if loc: node.SetLocation(loc[0], loc[1])
		if name: node.SetName(name)
		node.SetInputsCollapsed(collapsed)
		
		# Set values of any Inputs passed
		for key, value in kw.items():
			if self.useExt == True:
				input = self.InputByName(node, key)
			else:
				input = node.InputByInternalName(key)
			self.SetInputValue(input, value)
			
		# Return a reference to the node
		return node
	
	def AlignNodes(self, left=200, separation=230, cols=False):
	
		nodes = self.AllNodes()
		self.root.SetLocation(10,10)
		
		if cols:
		
			dummy = []
			for i in self.root.Inputs():
				n = i.InNode()
				if n:
					self.Traverse(n, dummy, xy=(left, separation))
		
		else:
		
			base = 1000000
			
			for node in nodes:
				
				if node == self.root: continue
				
				x = node.Location()[0]
				base = min(base, x) 
			
			base_mod = base - left
				
			for node in nodes:
			
				if node == self.root:
					continue
					
				x, y = node.Location()
				x -= base_mod
				
				if x < left:
					newx = left
				else:
					nx = x - left
					halfway = separation / 2
					column = int((nx + halfway) / separation)
					newx = left + (separation * column)
					
				node.SetLocation(newx, y)
	
	def AllNodes(self):
		''' Gets all nodes in the shader tree '''
		return self.tree.Nodes()
		
	def ApplyTextureFilters(self, value):
		''' Sets Texture Filtering for all identified imagemaps '''
		for map in self.Maps():
			if map:
				map.InputByInternalName('Filtering').SetFloat(value)
	
	def Bump_Value(self):
		''' Gets the value of the PoserSurface's Bump Input '''
		return self.root.InputByInternalName('Bump').Value()
		
	def ClearPoserSurface(self, keepTrans=False, severe=False):
		
		''' Prepares the PoserSurface for a new shader '''
		
		ps = self.Root()
		
		# Clear Diffuse, Specular and Ambient values
		ps.InputByInternalName('Diffuse_Value').SetFloat(0.0)		
		ps.InputByInternalName('Highlight_Color').SetColor(0.0, 0.0, 0.0)
		ps.InputByInternalName('Highlight_Value').SetFloat(0.0)		
		ps.InputByInternalName('Ambient_Value').SetFloat(0.0)
		ps.InputByInternalName('AlternateSpecular').Disconnect()
		
		# Clear Transparency and Translucent values
		if keepTrans == False:
			ps.InputByInternalName('Transparency_Max').SetFloat(0.0)
			ps.InputByInternalName('Transparency_Min').SetFloat(0.0)
			ps.InputByInternalName('Translucence_Value').SetFloat(0.0)	
			ps.InputByInternalName('Transparency_Max').Disconnect()
			ps.InputByInternalName('Transparency_Min').Disconnect()
		
		# Clear remaining values
		ps.InputByInternalName('Translucence_Color').Disconnect()
		ps.InputByInternalName('Reflection_Color').Disconnect()
		ps.InputByInternalName('Reflection_Value').Disconnect()
		ps.InputByInternalName('AlternateDiffuse').Disconnect()
		ps.InputByInternalName('AlternateSpecular').Disconnect()
		ps.InputByInternalName('Bump').Disconnect()
		
		# Clear Reflection*Mult values
		ps.InputByInternalName('ReflectionLiteMult').SetFloat(0.0)
		ps.InputByInternalName('ReflectionKdMult').SetFloat(0.0)
		
		# If requested, disconnect all nodes from the PoserSurface
		if severe == True:
			for i in ps.Inputs():
				i.Disconnect()
		
		# Standardise appearance of PoserSurface
		self.ConfigureNode(ps, loc=(10,10), showInputs=True, showPreview=True)

	def ConfigureNode(self, node, loc=None, name=None, showPreview=None, showInputs=None):
	
		''' Updates an existing node's parameters '''
		
		if loc: node.SetLocation(loc[0], loc[1])
		if name: node.SetName(name)
		if showPreview != None: node.SetPreviewCollapsed((0, 1)[showPreview == True])
		if showInputs != None: node.SetInputsCollapsed((1, 0)[showInputs == True])
	
	def ConnectNodes(self, n1, n2, inp):
	
		''' Connects Node 'n1' to Node 'n2's 'inp' Input '''
		if self.useExt == True:
			n1.ConnectToInput(self.InputByName(n2, inp))
		else:
			n1.ConnectToInput(n2.InputByInternalName(inp))	
				
	def ConnectToPS(self, node, input, value=None):
		if self.useExt == True:
			i = self.InputByName(self.root, input)
		else:
			i = self.root.InputByInternalName(input)
		node.ConnectToInput(i)
		if value:
			self.SetInputValue(i, value)
	
	def DefineNodeTypes(self, version, compatibility=False):
	
		''' Cross reference Node names with Poser Node codes '''
		
		if compatibility:
			self.codes = {
				"anisotropic" : poser.kNodeTypeCodeANISOTROPIC,
				"blender" : poser.kNodeTypeCodeBLENDER,
				"blinn" : poser.kNodeTypeCodeBLINN,
				"clouds" : poser.kNodeTypeCodeCLOUDS,
				"color" : poser.kNodeTypeCodeSIMPLECOLOR,
				"color_math" : poser.kNodeTypeCodeCOLORMATH,
				"component" : poser.kNodeTypeCodeCOMP,
				"color_math": poser.kNodeTypeCodeCOLORMATH,
				"diffuse" : poser.kNodeTypeCodeDIFFUSE,
				"edge_blend" : poser.kNodeTypeCodeEDGEBLEND,
				"fractal" : poser.kNodeTypeCodeFRACTALSUM,
				"glossy" : poser.kNodeTypeCodeGLOSSY,
				"hsv" : poser.kNodeTypeCodeHSV,
				"imagemap" : poser.kNodeTypeCodeIMAGEMAP,
				"math" : poser.kNodeTypeCodeMATH,
				"n" : poser.kNodeTypeCodeN,
				"noise" : poser.kNodeTypeCodeNOISE,
				"p" : poser.kNodeTypeCodeP,
				"phong" : poser.kNodeTypeCodePHONG,
				"reflect" : poser.kNodeTypeCodeREFLECT,
				"scatter" : poser.kNodeTypeCodeSCATTER,
				'specular' : poser.kNodeTypeCodeSPECULAR,
				'sphere_map' : poser.kNodeTypeCodeSPHEREMAP,		
				"turbulence" : poser.kNodeTypeCodeTURBULENCE,
				}
		

			if version >= 9:
				self.codes.update((
					("custom_scatter", poser.kNodeTypeCodeCustomScatter),
					("fresnel_blend", "fresnel_blend"),
					("microfacet", poser.kNodeTypeCodeMICROFACET),
					('sss', poser.kNodeTypeCodeSCATTERSKIN)))
				
		else:
			self.codes = {
				"ambient_occlusion" : poser.kNodeTypeCodeAMBIENTOCCLUSION,
				"aniso" : poser.kNodeTypeCodeANISOTROPIC,
				"atmosphere" : poser.kNodeTypeCodeATMOSPHERE,
				"background" : poser.kNodeTypeCodeBACKGROUND,
				"blender" : poser.kNodeTypeCodeBLENDER,
				"blinn" : poser.kNodeTypeCodeBLINN,
				"brick" : poser.kNodeTypeCodeBRICK,
				"cellular" : poser.kNodeTypeCodeCELLULAR,
				"clay" : poser.kNodeTypeCodeCLAY,
				"clouds" : poser.kNodeTypeCodeCLOUDS,
				"color_math" : poser.kNodeTypeCodeCOLORMATH,
				"colorramp" : poser.kNodeTypeCodeCOLORRAMP,
				"comp" : poser.kNodeTypeCodeCOMP,
				"custom_scatter" : poser.kNodeTypeCodeCustomScatter,
				"diffuse" : poser.kNodeTypeCodeDIFFUSE,
				"dNdu" : poser.kNodeTypeCodeDNDU,
				"dNdv" : poser.kNodeTypeCodeDNDV,
				"dPdu" : poser.kNodeTypeCodeDPDU,
				"dPdv" : poser.kNodeTypeCodeDPDV,
				"Du" : poser.kNodeTypeCodeDU,
				"Dv" : poser.kNodeTypeCodeDV,
				"edge_blend" : poser.kNodeTypeCodeEDGEBLEND,
				"fastscatter" : poser.kNodeTypeCodeFASTSCATTER,
				"fbm" : poser.kNodeTypeCodeFBM,
				"fractal_sum" : poser.kNodeTypeCodeFRACTALSUM,
				"frame_number" : poser.kNodeTypeCodeFRAME,
				"fresnel" : poser.kNodeTypeCodeFRESNEL,
				"fresnel_blend" : "fresnel_blend",
				"gamma" : poser.kNodeTypeCodeGAMMA,
				"gather" : poser.kNodeTypeCodeGATHER,
				"glossy" : poser.kNodeTypeCodeGLOSSY,
				"granite" : poser.kNodeTypeCodeGRANITE,
				"hair" : poser.kNodeTypeCodeHAIR,
				"hsv" : poser.kNodeTypeCodeHSV,
				"image_map" : poser.kNodeTypeCodeIMAGEMAP,
				"light" : poser.kNodeTypeCodeLIGHT,
				"marble" : poser.kNodeTypeCodeMARBLE,
				"math_functions" : poser.kNodeTypeCodeMATH,
				"ks_microfacet" : poser.kNodeTypeCodeMICROFACET,
				"movie" : poser.kNodeTypeCodeMOVIE,
				"N" : poser.kNodeTypeCodeN,
				"noise" : poser.kNodeTypeCodeNOISE,
				"P" : poser.kNodeTypeCodeP,
				"phong" : poser.kNodeTypeCodePHONG,
				"polygonhair" : poser.kNodeTypeCodePOLYGONHAIR,
				"poser" : poser.kNodeTypeCodePOSERSURFACE,
				"posterize" : poser.kNodeTypeCodePOSTERIZE,
				"probeLight" : poser.kNodeTypeCodePROBELIGHT,
				"reflect" : poser.kNodeTypeCodeREFLECT,
				"refract" : poser.kNodeTypeCodeREFRACT,
				"scatter" : poser.kNodeTypeCodeSCATTER,
				"skin2" : poser.kNodeTypeCodeSCATTERSKIN,
				"simple_color" : poser.kNodeTypeCodeSIMPLECOLOR,
				"skin" : poser.kNodeTypeCodeSKIN,
				"specular" : poser.kNodeTypeCodeSPECULAR,
				"sphere_map" : poser.kNodeTypeCodeSPHEREMAP,
				"spots" : poser.kNodeTypeCodeSPOTS,
				"tile" : poser.kNodeTypeCodeTILE,
				"toon" : poser.kNodeTypeCodeTOON,
				"turbulence" : poser.kNodeTypeCodeTURBULENCE,
				"s" : poser.kNodeTypeCodeU,
				"user_defined" : poser.kNodeTypeCodeUSERDEFINED,
				"t" : poser.kNodeTypeCodeV,
				"velvet" : poser.kNodeTypeCodeVELVET,
				"wave2d" : poser.kNodeTypeCodeWAVE2D,
				"wave3d" : poser.kNodeTypeCodeWAVE3D,
				"weave" : poser.kNodeTypeCodeWEAVE,
				"wood" : poser.kNodeTypeCodeWOOD
				}
	
	def Diffuse_Color(self):
		return self.root.InputByInternalName('Diffuse_Color').Value()
	
	def FindAKindOfNode(self, node, type):
		if not node:
			return None
		if node.Type() == type:
			return node
		for inp in node.Inputs():
			v = inp.InNode()
			found = self.FindAKindOfNode(v, type)
			if found:
				return found
		return None
		
	def FindMapNode(self, input):
		node = input.InNode()
		if node:
			mapnode = self.FindAKindOfNode(node, poser.kNodeTypeCodeIMAGEMAP)
		else:
			mapnode = None
		return mapnode
	
	def GC(self, node, gc, data):
		'''
		data is True/False. If True, the node is plugged into a channel which requires linear data
		'''	
		if gc:
			if node.Type() == poser.kNodeTypeCodeIMAGEMAP and poser.IsPro():
				texture = node.InputByInternalName('Image_Source').Texture()
				if texture:
					if not data:
						texture.SetUseSceneGamma(1)
					else:
						kd = self.GetMap('color')
						if kd:
							if node.InputByInternalName('Image_Source').Value() == kd.InputByInternalName('Image_Source').Value():
								return node
							else:
								texture.SetGamma(1.0)
						else:
							texture.SetGamma(1.0)	
		return node
		
	def GetMap(self, type):
		map = self.mapnodes[self.mapidx.index(type.lower())]
		if type.lower() == 'color' and map is None:
			map = self.mapnodes[self.mapidx.index('alt_color')]
		elif type.lower() == 'specular' and map is None:
			map = self.mapnodes[self.mapidx.index('alt_specular')]
		return map
	
	def GetMapNodes(self):
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Diffuse_Color')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('AlternateDiffuse')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Highlight_Value')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('AlternateSpecular')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Bump')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Displacement')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Transparency_Max')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Reflection_Color')))
		self.mapnodes.append(self.FindMapNode(self.Root().InputByInternalName('Highlight_Color')))

	def GetMode(self):
		return self.useExt
		
	def GetPSValue(self, input):
		if self.useExt == True:
			name = self.InputByName(self.root, input).InternalName()
			return self.root.InputByInternalName(name).Value()
		else:
			return self.root.InputByInternalName(input).Value()
			
	def HasBumpMap(self):
		return (True, False)[self.mapnodes[4] is None]
	
	def HasSpecularColourMap(self):
		map = self.GetMap('specular_color')
		if map == None:
			return False
		else:
			return True	

	def HasSpecularMap(self):
		map = self.GetMap('specular')
		if map == None:
			return False
		else:
			return True
	
	def InputByName(self, node, name):
		type = node.Type()
		xref = self.names.get(type, None)
		if xref == None:
			lookup = {}
			for i in node.Inputs():
				lookup[i.Name()] = i.InternalName()
			self.names[type] = lookup
			xref = self.names.get(type, None)
		try:
			return node.InputByInternalName(xref[name])
		except:
			ShowAlert('Unknown Input (%s) in node type %s' % (name, type), 'Script error!')
	
	def InsertBlender(self, target, input, colour, value, loc=(20,20), name=None, collapsed=True):
		
		mode = self.GetMode(); self.SetMode(True)
		
		originalNode = target.InNode()
		col = ((1,1,1), (0,0,0))[originalNode == None]
		
		if input == 0:
			n01 = self.AddNode('blender', name=name, loc=loc, collapsed=collapsed, Input_2=col, Input_1=colour, Blending=value)
			if originalNode:
				self.ConnectNodes(originalNode, n01, 'Input_2')
		else:
			n01 = self.AddNode('blender', name=name, loc=loc, collapsed=collapsed, Input_1=col, Input_2=colour, Blending=value)
			if originalNode:
				self.ConnectNodes(originalNode, n01, 'Input_1')
			
		self.tree.AttachTreeNodes(target.ItsNode(), target.InternalName(), n01)
		
		self.SetMode(mode)
		return n01
		
	def MapName(self, mapnode):
		map = None
		if mapnode:
			map = (mapnode.Input(0).Value(), None)[mapnode.Input(0).Value() == "" or mapnode.Input(0).Value() == "NO_MAP"]
		return map
		
	def Maps(self):
		return self.mapnodes

	def MapPaths(self):
		return [self.MapName(x) for x in self.Maps()]
		
	def Material(self):
		return self.material
	
	def Name(self):
		return self.material.Name()
	
	def PSInputByName(self, name):
		return self.InputByName(self.root, name)

	def RemoveOrphans(self):
		usedNodes = []
		usedNodes.append(self.root)
		self.Traverse(self.root, usedNodes)
		for node in self.tree.Nodes():
			try:
				index = usedNodes.index(node.InternalName())
			except:
				node.Delete()
		self.UpdatePreview()
		
	def Traverse(self, node, usedNodes, col=0, xy=None):
	
		usedNodes.append(node.InternalName())
		
		if xy:
			y = node.Location()[1]
			node.SetLocation(xy[0]+(col*xy[1]), y)
			nextcol = col + 1
		
		for inp in node.Inputs():
			
			inNode = inp.InNode()
			
			if (inNode != None):
				
				if xy:
					self.Traverse(inNode, usedNodes, nextcol, xy)
				else:
					self.Traverse(inNode, usedNodes)
			
	def Root(self):
		return self.root
	
	def SameAsKdTexture(self, node):
		kd = self.GetMap('color')
		if kd:
			if node.InputByInternalName('Image_Source').Value() == kd.InputByInternalName('Image_Source').Value():
				return True
		return False
		
	def SetBump_Value(self, value):
		self.root.InputByInternalName('Bump').SetFloat(value)
		
	def SetInputValue(self, input, value):
		if input:
			inputType = input.Type()
			if inputType in [0, 4, 6]:
				try: input.SetFloat(value)
				except: pass
			elif inputType in [1, 2]:
				try: 
					r, g, b = value
					input.SetColor(r, g, b)
				except: pass
			elif inputType == 3:
				try: input.SetString(value)
				except: pass
	
	def SetMapPath(self, node, path):
		if node and node.Type() == 'image_map':
			node.Input(0).SetString(path)
	
	def SetMode(self, useExt=True):
		if useExt == True:
			self.useExt = True
		else:
			self.useExt = False
	
	def SetPSValue(self, input, value):
		if self.useExt == True:
			self.SetInputValue(self.InputByName(self.root, input), value)
		else:
			self.SetInputValue(self.root.InputByInternalName(input), value)
	
	def UpdatePreview(self):
		self.tree.UpdatePreview()
		
class UI(MagicBox):
	def __init__(self):
		MagicBox.__init__(self, None)
		self.SetDefaults(None)
		
		self.menuitems = []
		self.macos = (False, True)[os.name == 'posix']

		# Read the presets configuraton file
		self.config = ConfigParser.RawConfigParser()
		self.presetsfile = os.path.join(poser.PrefsLocation(), 'magicbox' + os.extsep + 'cfg')
		self.config.read(self.presetsfile)
		self.InitialisePresets()
		
		self.controls = {
			'tophi' : (self.ctl_TOPHi, "str"),
			'toplo' : (self.ctl_TOPLo, "str"),
			'midhi' : (self.ctl_MIDHi, "str"),
			'midlo' : (self.ctl_MIDLo, "str"),
			'bothi' : (self.ctl_BOTHi, "str"),
			'botlo' : (self.ctl_BOTLo, "str"),
			}
		
		self.UpdateStatusBar()
		poser.Scene().SetEventCallback(self.ProcessCallback)

	def __del__(self):
		if not self.macos: poser.Scene().ClearEventCallback()
		
		# Write the presets config file to disk
		try:
			cfgfile = open(self.presetsfile, 'wb')
			self.config.write(cfgfile)
			cfgfile.close()
		except:
			ShowAlert('Unable to open configuration file for writing')

	def AddPresetToMenu(self, name):
		
		self.menuitems.append(name)
		self.menuitems.sort()
		pos = self.menuitems.index(name) + 3
		
		# Create a menu item
		item = wx.MenuItem( self.mnu_Presets, wx.ID_ANY, name, wx.EmptyString, wx.ITEM_NORMAL )
		
		# Add it to the menu
		self.mnu_Presets.InsertItem(pos, item)
		
		# Link it to our self.ApplyPreset method
		self.Bind( wx.EVT_MENU, self.LoadPreset, id = item.GetId() )
		
	def Apply( self, event ):
		scene = poser.Scene()
		actor = scene.CurrentActor()
		act = poserActor(actor)
		
		try:
			TOP_HI = float(self.ctl_TOPHi.GetValue())
			TOP_LO = float(self.ctl_TOPLo.GetValue())
			MID_HI = float(self.ctl_MIDHi.GetValue())
			MID_LO = float(self.ctl_MIDLo.GetValue())
			BOT_HI = float(self.ctl_BOTHi.GetValue())
			BOT_LO = float(self.ctl_BOTLo.GetValue())
		except:
			ShowAlert('One or more values are invalid numbers')
			return
		
		try:
			mezigzag = (None, scene.Figure('MEZIGZAG'))[self.ctl_Sync.IsChecked()]
		except:
			mezigzag = None
			
		if mezigzag:
			yt = mezigzag.Actor('Body').ParameterByCode(poser.kParmCodeYTRAN).Value() * 103.2
		else:
			yt = 0.0

		if act.IsNotReal(AllowBodyParts=True):
			ShowAlert('Invalid actor')
			return
			
		if actor.IsBodyPart():
			object = actor.ItsFigure()
		else:
			object = actor

		for material in object.Materials():
			mat = poserMat(material, POSER_VERSION, useExt=True)
			
			n01 = mat.AddNode('blender', loc=(250, 200), collapsed=False, Input_1=(0,0,0), Input_2=(1,1,1), Blending=1.0)
			
			n02 = mat.AddNode('math_functions', loc=(500, 200), Math_Argument=16, Value_1=1.0, Value_2=1.0)
			n03 = mat.AddNode('math_functions', loc=(500, 230), Math_Argument=16, Value_1=1.0, Value_2=1.0)
			mat.ConnectNodes(n02, n03, 'Value_1')
			mat.ConnectNodes(n03, n01, 'Blending')
			
			y = 200
			
			top = not self.ctl_Top.IsChecked()
			mid = not self.ctl_Middle.IsChecked()
			low = not self.ctl_Bottom.IsChecked()
			
			n04 = mat.AddNode('math_functions', loc=(750, y+0), Math_Argument=03, Value_1=top, Value_2=1.0)
			n05 = mat.AddNode('math_functions', loc=(750, y+30), Math_Argument=21, Value_1=1.0, Value_2=TOP_HI+yt)
			n06 = mat.AddNode('math_functions', loc=(750, y+60), Math_Argument=21, Value_1=TOP_LO+yt, Value_2=1.0)
			
			n07 = mat.AddNode('math_functions', loc=(750, y+90), Math_Argument=03, Value_1=mid, Value_2=1.0)
			n08 = mat.AddNode('math_functions', loc=(750, y+120), Math_Argument=21, Value_1=1.0, Value_2=MID_HI+yt)
			n09 = mat.AddNode('math_functions', loc=(750, y+150), Math_Argument=21, Value_1=MID_LO+yt, Value_2=1.0)
			
			n10 = mat.AddNode('math_functions', loc=(750, y+180), Math_Argument=03, Value_1=low, Value_2=1.0)
			n11 = mat.AddNode('math_functions', loc=(750, y+210), Math_Argument=21, Value_1=1.0, Value_2=BOT_HI+yt)
			n12 = mat.AddNode('math_functions', loc=(750, y+240), Math_Argument=21, Value_1=BOT_LO+yt, Value_2=1.0)
			
			mat.ConnectNodes(n05, n04, 'Value_1')
			mat.ConnectNodes(n06, n04, 'Value_2')
			mat.ConnectNodes(n08, n07, 'Value_1')
			mat.ConnectNodes(n09, n07, 'Value_2')			
			mat.ConnectNodes(n11, n10, 'Value_1')
			mat.ConnectNodes(n12, n10, 'Value_2')
			
			mat.ConnectNodes(n04, n02, 'Value_1')
			mat.ConnectNodes(n07, n02, 'Value_2')
			mat.ConnectNodes(n10, n03, 'Value_2')
			
			n13 = mat.AddNode('P', loc=(750, y+300), x=0, y=P_UNIT, z=0)
			
			mat.ConnectNodes(n13, n05, 'Value_1')
			mat.ConnectNodes(n13, n06, 'Value_2')
			mat.ConnectNodes(n13, n08, 'Value_1')
			mat.ConnectNodes(n13, n09, 'Value_2')
			mat.ConnectNodes(n13, n11, 'Value_1')
			mat.ConnectNodes(n13, n12, 'Value_2')
			
			targetInput = mat.InputByName(mat.Root(), 'Transparency')
			bl = mat.InsertBlender(targetInput, 0, (0,0,0), 1.0, loc=(250, 100), collapsed=False, name='TransBlend')
			mat.SetInputValue(mat.InputByName(bl,'Input_2'),(1,1,1))
			
			mat.ConnectNodes(n01, bl, 'Blending')
			mat.SetPSValue('Transparency', 1.0)
			mat.SetPSValue('Transparency_Falloff', 0.0)
			mat.SetPSValue('Transparency_Edge', 0.0)


			if mat.GetPSValue('Specular_Color') == (0,0,0) or mat.GetPSValue('Specular_Value') == 0.0:
				spec = False
				targetInput = mat.InputByName(mat.Root(), 'Alternate_Specular')
				n14 = mat.PSInputByName('Alternate_Specular').InNode()
			else:
				spec = True
				n14 = mat.AddNode('specular', loc=(500, 20), collapsed=False, Specular_Color=mat.GetPSValue('Specular_Color'), Specular_Value=mat.GetPSValue('Specular_Value'))
				targetInput = mat.InputByName(mat.Root(), 'Specular_Color')
				
			bl2 = mat.InsertBlender(targetInput, 0, (0,0,0), 1.0, loc=(250, 20), collapsed=False, name='SpecBlend')

			if n14: mat.ConnectNodes(n14, bl2, 'Input_2')
			mat.ConnectNodes(n01, bl2, 'Blending')
			if spec:
				mat.SetInputValue(mat.InputByName(bl2,'Input_2'),(1,1,1))
				mat.SetPSValue('Specular_Value', 1.0)
				mat.SetPSValue('Specular_Color', (1,1,1))
			
			mat.RemoveOrphans()
			mat.UpdatePreview()
			
			material.SetSelected(1)
		
		if self.ctl_MakeMC6.IsChecked():
			tempfile = os.path.join(poser.TempLocation(), 'mmb.mc6')
			actor.SaveMaterialCollection(tempfile)
			actor.LoadMaterialCollection(tempfile)
			
		scene.DrawAll()
		ShowAlert('All done')

	def DeletePreset(self, name):
		self.config.remove_section(name)
		id = self.mnu_Presets.FindItem(name)
		if id:
			self.mnu_Presets.DeleteItem(self.mnu_Presets.FindItemById(id))
			try:
				self.menuitems.remove(name)
			except:
				pass
		self.modified = True
		
	def InitialisePresets(self):
		# get a list of all presets from our configuration file
		presets = self.config.sections()
		
		# And add them to the menu
		for preset in presets:
			self.AddPresetToMenu(preset)

	def LoadPreset( self, event, preset=None, quiet=False):
		
		if preset == None:
			# Find the relevant menu item
			id = event.GetId()
			item = self.mnu_Presets.FindItemById(id)
		
			# Get its name
			preset = item.GetLabel()
		
		if self.config.has_section(preset):	# Check that the preset exists in the configuration file
		
			# Get all the settings for that preset
			for option, value in self.config.items(preset):
				
				# Make sure our dictionary knows about the setting
				if self.controls.has_key(option):
					
					# Get a reference to our control and its type by looking it up in our dictionary
					control, type = self.controls[option]
					
					# Read and apply the value
					if type == 'ignore':
						continue
					elif type == 'int':
						control.SetValue(self.config.getint(preset, option))
					elif type == 'bool':
						control.SetValue(self.config.getboolean(preset, option))
					elif type == 'str':
						control.SetValue(self.config.get(preset, option))
					elif type == 'col':
						control.SetColour(self.config.get(preset, option))
					elif type == 'sel':
						control.SetSelection(self.config.getint(preset, option))
					elif type == 'tex':
						tex = control.FindItem(0, self.config.get(preset, option), False)
						if tex != -1:
							control.Select(tex, True)
					elif type == 'offon':
						control.Enable(self.config.getboolean(preset, option))
					elif type == 'path':
						control.SetPath(self.config.get(preset, option))
				else:
					pass
			
		else:
			if not quiet: ShowAlert('Preset %s not found in presets file' % preset)

	def Manage( self, event ):
	
		self.ModalStart()
		
		# Create the dialog and show it
		dlg = Selector(self.config.sections(), 'Delete presets', 'Delete selected')
		retcode = dlg.ShowModal()
		
		# Process the user's selection
		if retcode == 1:
			for preset in dlg.ctl_PresetList.GetCheckedStrings():
				self.DeletePreset(preset)
		
		# Delete the dialog
		dlg.Destroy()
		
		self.ModalStop()

	def ModalStart(self):
		if not self.macos: poser.Scene().ClearEventCallback()
	
	def ModalStop(self):
		if not self.macos: poser.Scene().SetEventCallback(self.ProcessCallback)
		
	def ProcessCallback(self, scene, event):
		if (event & poser.kEventCodeACTORSELECTIONCHANGED) or (event & poser.kEventCodeACTORDELETED):
			self.UpdateStatusBar()
		self.SetFocus()

	def Save( self, event):
	
		self.ModalStart()
		
		# Ask the user to give the preset aname
		dialog = wx.TextEntryDialog(None, "Preset name:", "Text Entry", "Default Value", style=wx.OK|wx.CANCEL)
		
		if dialog.ShowModal() == wx.ID_OK:	# And if they do ...
		
			# Make a note of the name
			preset = dialog.GetValue()
			
			# The name 'DEFAULT' is reserved for our use
			if preset.lower() == 'default':
				ShowAlert("You are not allowed to use the name '%s'" % preset, APPNAME)
			
			# If the preset already exists, ask the user whether or not it should be overwritten
			elif self.config.has_section(preset):
			
				# Contruct the dialog box
				dlg = wx.MessageDialog(None, "Overwrite existing preset?", "Preset name already exists", wx.YES_NO | wx.ICON_QUESTION)
				
				# Check that the user said it was ok to overwrite the preset
				if dlg.ShowModal() == wx.ID_YES:
					
					# Destroy the dialog box and update the preset settings
					dlg.Destroy()
					self.UpdatePreset(preset)
			else:
				
				# Create the preset in the configuration file
				self.config.add_section(dialog.GetValue())
				
				# And add it to the menu
				self.AddPresetToMenu(preset)
				
				# And update the settings for the preset in the configuration file
				self.UpdatePreset(preset)
				
		dialog.Destroy()
		self.ModalStop()
		
	def SetDefaults(self, event):
		self.ctl_TOPHi.SetValue('76')
		self.ctl_TOPLo.SetValue('52')
		self.ctl_MIDHi.SetValue('52')
		self.ctl_MIDLo.SetValue('28')
		self.ctl_BOTHi.SetValue('28')
		self.ctl_BOTLo.SetValue('0')
	
	def UpdatePreset(self, preset):
		
		# If the preset doesn't exist yet, then create it
		if not self.config.has_section(preset):
			self.config.add_section(preset)
		
		# Add or update config options to preset
		for option, value in self.controls.items():
			control, type = value
			if type == 'str':
				self.config.set(preset, option, control.GetValue())
			elif type in ('int', 'float', 'bool'):
				self.config.set(preset, option, str(control.GetValue()))
			elif type == 'col':
				col = control.GetColour()
				if isinstance(col, wx.Colour): col = col.GetAsString()
				self.config.set(preset, option, col)
			elif type == 'sel':
				self.config.set(preset, option, str(control.GetSelection()))
			elif type == 'tex':
				selected = control.GetFirstSelected()
				if selected >= 0:
					self.config.set(preset, option, control.GetItemText(selected))
			elif type == 'offon':
				self.config.set(preset, option, str(control.IsEnabled()))
			elif type == 'path':
				self.config.set(preset, option, control.GetPath())
		
	def UpdateStatusBar(self):
		target = poserActor(poser.Scene().CurrentActor()).Name(True)
		self.ctl_StatusBar.SetStatusText('Target: %s' % target)		
		
class Main(object):
		def __init__(self):
		
			#Check that a supported version of Poser is running
			if POSER_VERSION < 9:
				ShowAlert('This script requires Poser 9 or later\nYou have version %s\nThis script does not work with your version of Poser' % POSER_VERSION)
			else:	
				ui = UI()
				ui.SetSizeWH(UI_WIDTH, UI_HEIGHT)
				ui.SetTitle(APPTITLE)
				ui.Show()
			
Main()